#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "err.h"

#define BUF_SIZE 4096

int main(int argc, char* argv[])
{
  int pi,ile;
  char str[BUF_SIZE];

  if (argc<2) {
    fprintf( stderr, "Call me:\n %s <pipe_name>\n", argv[0]);
    exit(1);
  }

  /* we make a named pipe for writing */
  printf("Before mkfifo...");
  if (mkfifo(argv[1], S_IRUSR|S_IWUSR) == -1) 
    syserr("Error in creating named pipe\n");
  printf("after\n");

  printf( "Before open for reading..." );
  pi=open(argv[1], O_RDONLY);
  if (pi < 0) 
    syserr("Error in opening named pipe\n");
  printf( "after\n" );

  /* we remove our pipe */
  printf( "Before unlink..." );
  unlink (argv[1]);  
  printf( "after\n" );

  ile = 1;
  while (ile > 0) {
    printf( "Before read...");
    ile=read(pi, str, BUF_SIZE-1);
    if (ile < 0)
      syserr("Error in reading from named pipe\n");
    printf( "after\n" );
    str[ile]='\0';
    printf( "%s", str);
    fflush(stdout);
  }
  
  return 0;
}
